package inria.meije.rc.sugarcubes;

public class Cube extends Freezable implements Link, Shell
{
    protected ShellImpl shell;
    protected Link link;
    protected JavaInstruction onTerminate, onFreeze, onWarmUp;
    protected JavaObjectExpression obj;

    public Cube(JavaStringExpression s,JavaObjectExpression o,Instruction b
                   ,JavaInstruction fin,JavaInstruction f,JavaInstruction w){
        super(s,b);
        obj = o; onWarmUp = w; onFreeze = f; onTerminate = fin;
    }
    public Cube(String s,Object o,Instruction i){
        this(new JavaStringValue(s),new JavaObjectValue(o),i
          ,new JavaEmptyInstruction(),new JavaEmptyInstruction(),new JavaEmptyInstruction());
    }
    public Cube(String s,Instruction i){ this(s,null,i); }

    public void add(Instruction inst){
        if(firstActivation){ body = new Merge(body,inst); return; }
        shell.add(inst);
    }
    public Instruction body(){
        if(firstActivation) return body;
        return shell.body();
    }
    public Object javaObject(){
        if(!firstActivation) return link.javaObject();
        System.err.println("Warning: Link not yet activated"); 
        return null;
   }
    public Link superLink(){ return link.superLink(); }
    public String toString(){
        return "cube "+name()+" "+body()+" on freeze "+onFreeze+" onWarmUp "+onWarmUp+" finalize "+onTerminate+" end";
    }
    protected Instruction rest(){
        return new Cube(nameExpression,new JavaObjectValue(javaObject()),body().residual(),onTerminate,onFreeze,onWarmUp);
    }
    protected void buildBody(){
        body = new Until(new PosConfig(name+"-destroy"),(link = new LinkImpl(obj,shell = new ShellImpl(name,body),onTerminate,onFreeze,onWarmUp)));
    }
    protected void firstActivation(Context context){
        super.firstActivation(context);
        buildBody();
        ((LinkImpl)link).setCube(this);
    }
    public void notifyWarmUpToJava(Context context){
        body.notifyWarmUpToJava(context);
        body = new Seq(new JavaAtom(onWarmUp),body);
    }
}
