package inria.meije.rc.sugarcubes;

public class Freezable extends UnaryInstruction implements NamedInstruction
{
    protected boolean reanim = false;
    protected String name = "noname";
    protected JavaStringExpression nameExpression = null;

    public Freezable(String n,Instruction i){
        this(new JavaStringValue(n),i);
    }
    public Freezable(JavaStringExpression n,Instruction i){
        body = i;nameExpression = n;
    }

    public String name(){ return name; }
    protected boolean doFreeze(Context context){
        if(firstActivation||terminated) return true;
        if(context.isToBeFrozen(name)){
                Freezable i = (Freezable) residual();
                i.reanim = true;
                context.storeFrozenInstruction(name,i);
                notifyFreezeToJava(context);
                body = new Nothing();terminated = true;
                return true;
        }
        return false;
    }
    public void freeze(Context context){
        if(doFreeze(context)) return;
        super.freeze(context);
    }
    public String toString(){
        return "freezable "+nameExpression+" "+body+" end";
    }
    protected Instruction rest(){
        return new Freezable(nameExpression,body.residual());
    }
    protected void firstActivation(Context context){
        name = nameExpression.evaluate(context.currentLink());
        nameExpression = new JavaStringValue(name);
        if(reanim){
            reanim = false;
            notifyWarmUpToJava(context);
        }
        super.firstActivation(context);
    }
}
