package inria.meije.rc.sugarcubes;

public class Repeat extends Cyclic
{
    protected int counter;
    protected JavaIntegerExpression intExp;

    public Repeat(int n,Instruction inst){ this(new JavaIntegerValue(n),inst); }
    public Repeat(JavaIntegerExpression exp,Instruction body){ super(body); intExp = exp; }

    protected Instruction rest(){ 
        if (counter <= 1) return body.residual();
        return new Seq(body.residual(),new Repeat(counter-1,freshBody()));
    }
    public String toString(){ return "loop "+intExp+" times "+body+" end"; }
    public void firstActivation(Context context){
    	counter = intExp.evaluate(context.currentLink());
    	super.firstActivation(context);
    }
    protected byte activation(Context context){
        for(;;){
            if (counter <= 0){ return TERM; }
            byte res = body.activ(context);
            if (res != TERM) return res;
            counter--; body = freshBody();
        }
    }
}
