package inria.meije.rc.sugarcubes;

public class Seq extends BinaryInstruction
{
    public Seq(Instruction left,Instruction right){
        this.left = left;
        this.right = right;
    }

    public String toString(){ return left+"; "+right; }
    protected Instruction rest(){
        if (left.isTerminated()) return right.residual();
        return new Seq(left.residual(),right);
    }
    protected byte activation(Context context){
        if (left.isTerminated()) return right.activ(context);
        byte res = left.activ(context);
        if (res != TERM) return res;
        return right.activ(context);
    }
    public void freeze(Context context){ 
        if(left.isTerminated())
            right.freeze(context);
        else
            left.freeze(context);
    }
    public void notifyTerminationToJava(Context context){
        if(left.isTerminated())
            right.notifyTerminationToJava(context);
        else
            left.notifyTerminationToJava(context);
	}
    public void notifyWarmUpToJava(Context context){
        if(left.isTerminated())
            right.notifyWarmUpToJava(context);
        else
            left.notifyWarmUpToJava(context);
    }
    public void notifyFreezeToJava(Context context){
        if(left.isTerminated())
            right.notifyFreezeToJava(context);
        else
            left.notifyFreezeToJava(context);
    }
}
